package SOFA.Component;


/** Component lifecycle control interface of the component manager.
  * Generated by SOFA CodeGen.
  */
public interface ComponentLifecycleControlOperations  {
  /** Build component internals.
    * @param  stateStore    storage for the component state
    * @exception ComponentLifecycleException  component cannot be built
    */
  void createComponent(SOFA.SOFAnode.Run.Storage stateStore) throws SOFA.Component.ComponentLifecycleException;
      /** Destroy component internals.
        * @param  stateStore    storage for the component state
        * @exception ComponentLifecycleException  component cannot be destroyed
        */
  void destroyComponent(SOFA.SOFAnode.Run.Storage stateStore) throws SOFA.Component.ComponentLifecycleException;
      /** Store component state - not implemented.
        * @param  stateStore    storage for the component state
        * @exception ComponentLifecycleException  component cannot be stored
        */
  void storeComponent(SOFA.SOFAnode.Run.Storage stateStore) throws SOFA.Component.ComponentLifecycleException;
      /** Restore component state - not implemented.
        * @param  stateStore    storage for the component state
        * @exception ComponentLifecycleException  component cannot be restored
        */
  void restoreComponent(SOFA.SOFAnode.Run.Storage stateStore) throws SOFA.Component.ComponentLifecycleException;
}
