package SOFA.Component;


/** Registry of leaving and incoming threads. ThreadIDRegistry is part of the 
  * component manager. It registers all threads leaving/entering the components.
  * It is used at the time of the dynamic update.
  * Generated by SOFA CodeGen.
  */
public interface ThreadIDRegistryOperations  {
      /** incoming call in new call
        * @param thr_id  thread id (it can be "null", operation returns correct id) 
        * @return   thread id
        */
  java.lang.String threadInCall(java.lang.String thr_id) ;
       /** leaving component of new call - complement to threadInCall
        * @param   thr_id  id of the leaving thread 
        * @return   id of leaving thread (same as thr_id parameter)
        */
  java.lang.String threadOutReturn(java.lang.String thr_id) ;
      /** call to other component - thread leaves component
        * @return   id of leaving thread
        */
  java.lang.String threadOutCall() ;
      /** returning of call to other component - complement to threadOutCall
        * @param thr_id  thread id  
        * @return   thread id
        */
  java.lang.String threadInReturn(java.lang.String thr_id) ;
}
