/*
 * JImpl.java
 *
 * Created on 2. duben 2002, 23:37
 */

package SOFA.Connector.EEG.EEM.Actions;

import SOFA.Connector.EEG.EEM.*;
import SOFA.SOFAnode.Made.TIR.*;
import SOFA.SOFAnode.Made.TIR.Access.TIRAccessMethods;
import SOFA.Connector.EEG.CodeWriter.*;
			
/**
 *
 * @author  ghort
 * @version 
 */
public class JImpl implements ActionInterface {

	/** Creates new JImpl */
   public JImpl(java.util.HashMap props) {
   }

	public String getName() {
		return "jimpl";
	}
	 
	public void perform(SOFA.Connector.Property[] params, String sourceDir, String sourcePackage, String destDir, String destPackage) throws ActionException {
		String outFile, className, reqIfaceCDL, provIfaceCDL, reqIfaceMapped=null, provIfaceMapped=null, generator;
		if ((outFile=SOFA.Connector.Property.findFirst(params,"file"))==null) {
			throw new ActionException("file param not specified");
		}
		if ((className=SOFA.Connector.Property.findFirst(params,"class"))==null) {
			throw new ActionException("class param not specified");
		}
		if ((generator=SOFA.Connector.Property.findFirst(params,"generator"))==null) {
			throw new ActionException("generator param not specified");
		}
		if ((provIfaceCDL=SOFA.Connector.Property.findFirst(params,"provIfaceCDL"))!=null) {
			provIfaceMapped=SOFA.Connector.Property.findFirst(params,"provIfaceMapped");
		}
		if ((reqIfaceCDL=SOFA.Connector.Property.findFirst(params,"reqIfaceCDL"))!=null) {
			reqIfaceMapped=SOFA.Connector.Property.findFirst(params,"reqIfaceMapped");
		}
		 
		try {
			SOFA.Connector.EEG.CodeWriter.JWriter jwriter;
			
			if (provIfaceCDL!=null) {
				jwriter=new SOFA.Connector.EEG.CodeWriter.JWriter(provIfaceCDL);
			} else {
				jwriter=new SOFA.Connector.EEG.CodeWriter.JWriter();
			}
			jwriter.setOut(destDir+"/"+outFile,destPackage,className);

			int addn=0;
			if (provIfaceCDL!=null && provIfaceMapped==null) {
				addn++;
			}
			if (reqIfaceCDL!=null && reqIfaceMapped==null) {
				addn++;
			}

			SOFA.Connector.Property[] dirParams=new SOFA.Connector.Property[params.length+4+addn];

			addn=0;
			if (provIfaceCDL!=null && provIfaceMapped==null) {
				InterfaceDef provIface=(InterfaceDef)TIRAccessMethods.lookupCDLContained(SOFA.Connector.TIRAccess.TIRAccess.repository,provIfaceCDL);
				provIfaceMapped=CDL2JavaMapping.getAbsoluteName(provIface.get_identification().absolute_name());
				dirParams[addn]=new SOFA.Connector.Property("provIfaceMapped",provIfaceMapped);
				addn++;
			}
			if (reqIfaceCDL!=null && reqIfaceMapped==null) {
				InterfaceDef reqIface=(InterfaceDef)TIRAccessMethods.lookupCDLContained(SOFA.Connector.TIRAccess.TIRAccess.repository,reqIfaceCDL);
				reqIfaceMapped=CDL2JavaMapping.getAbsoluteName(reqIface.get_identification().absolute_name());
				dirParams[addn]=new SOFA.Connector.Property("reqIfaceMapped",reqIfaceMapped);
				addn++;
			}

			dirParams[addn+0]=new SOFA.Connector.Property("outFile",destDir+"/"+outFile);
			dirParams[addn+1]=new SOFA.Connector.Property("outClass",className);
			dirParams[addn+2]=new SOFA.Connector.Property("outPackage",destPackage);
			dirParams[addn+3]=new SOFA.Connector.Property("implIface",provIfaceMapped);
			
			
			for (int i=0;i<params.length;i++) {
				dirParams[i+addn+4]=params[i];
			}
			
			Class dirClass=Class.forName(sourcePackage+"."+generator);

			Class[] coParCls=new Class[2];
			coParCls[0]=Class.forName("java.lang.String");
			coParCls[1]=Class.forName("[LSOFA.Connector.Property;");
			java.lang.reflect.Constructor dirClassCo=dirClass.getConstructor(coParCls);

			Object[] coPar=new Object[2];
			coPar[0]=provIfaceCDL;
			coPar[1]=dirParams;
			SOFA.Connector.EEG.CodeWriter.JWriterDirector director=(SOFA.Connector.EEG.CodeWriter.JWriterDirector)dirClassCo.newInstance(coPar);

			if (provIfaceCDL!=null) {
				jwriter.write(director,provIfaceMapped);
			} else {
				jwriter.write(director);
			}
			 
		} catch (Exception e) {
			throw new ActionException("Can't generate java source "+destDir+"/"+outFile+".",e);
		}
	}
	 
}
