/* $Id: ByteArrayInputStream.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */

package cz.cuni.sofa.lib.Impl;
import java.io.IOException;

/** Implementation of InputStream over byte array.
  */
public class ByteArrayInputStream extends cz.cuni.sofa.lib.InputStream {
  private java.io.ObjectInputStream in;
  private java.io.ByteArrayInputStream internal;

  public ByteArrayInputStream(byte[] buff) throws IOException {
    internal = new java.io.ByteArrayInputStream (buff);
    in = new java.io.ObjectInputStream(internal);
  }

  public ByteArrayInputStream(String buff) throws IOException {
    internal = new java.io.ByteArrayInputStream (buff.getBytes());
    in = new java.io.ObjectInputStream(internal);
  }

  public int read() throws IOException {
    return in.read();
  }

  public boolean read_boolean() throws IOException {
    return in.readBoolean();
  }

  public char read_char() throws IOException {
    return in.readChar();
  }
  
  public char read_wchar() throws IOException {
    return in.readChar();
  }
  public byte read_octet() throws IOException {
    return in.readByte();
  }
  
  public short read_short() throws IOException {
    return in.readShort();
  }
  
  public short read_ushort() throws IOException {
    return in.readShort();
  }
  
  public int read_long() throws IOException {
    return in.readInt();
  }
  
  public int read_ulong() throws IOException {
    return in.readInt();
  }
  
  public long read_longlong() throws IOException {
    return in.readLong();
  }
  
  public long read_ulonglong() throws IOException {
    return in.readLong();
  }
  
  public float read_float() throws IOException {
    return in.readFloat();
  }
  
  public double read_double() throws IOException {
    return in.readDouble();
  }
  
  public String read_string() throws IOException {
    return in.readUTF();
  }
  
  public String read_wstring() throws IOException {
    return in.readUTF();
  }

  public void read_boolean_array(boolean[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readBoolean();
    }
  }

  public void read_char_array(char[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readChar();
    }
  }
  
  public void read_wchar_array(char[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readChar();
    }
  }
  
  public void read_octet_array(byte[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readByte();
    }
  }
  
  public void read_short_array(short[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readShort();
    }
  }
  public void read_ushort_array(short[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readShort();
    }
  }
  
  public void read_long_array(int[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readInt();
    }
  }
  
  public void read_ulong_array(int[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readInt();
    }
  }
  
  public void read_longlong_array(long[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readLong();
    }
  }
  
  public void read_ulonglong_array(long[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readLong();
    }
  }
  
  public void read_float_array(float[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readFloat();
    }
  }
  
  public void read_double_array(double[] value, int offset, int length) throws IOException {
    for(int i=0; i<length; i++) {
      value[offset+i] = in.readDouble();
    }
  }

  public cz.cuni.sofa.lib.Object read_Object() throws IOException {
    try {
      return (cz.cuni.sofa.lib.Object) in.readObject();
    } catch (ClassNotFoundException e) {
      throw new IOException(e.getMessage());
    }
  }
}
