/**
 * InOut2ClientCRole.java is a part of the SOFA project.
 * This file was created by pepan on 16.4.2003.
 */
package SOFA.SOFAnode.InOut.Connector;

import SOFA.Connector.*;
import SOFA.SOFAnode.InOut.*;

/**
 * @author Petr Panuska
 */
public class InOut2ClientCRole extends RoleBaseImpl implements InOut2Client {
  private CNInOut2Client target;

  public void link (Object target) throws LinkException {
    try {
      if (target instanceof Reference) {
        Reference ref = (Reference) target;
        setSOFAReference(ref);
        TaggedProfile[] profiles = ref.profiles;
        for (int i = 0; i < profiles.length; i++) {
          if (profiles[i].tag.equals("LOCAL")) {
            this.target = (CNInOut2Client) ((SOFA.Connector.ECG.Profiles.LocalProfile) profiles[i]).link;
            return;
          } else if (profiles[i].tag.equals("RMI")) {
            this.target = new InOut2ClientRMIStub(((SOFA.Connector.ECG.Profiles.RMIProfile) profiles[i]).URL);
            return;
          }
        }
      } else {
        this.target = (CNInOut2Client) target;
      }
    } catch (Exception e) {
      throw new LinkException("Can't link InOut2ClientCRole. ", e);
    }
  }

/*
  public void obtainComponent (String fullName, String sofanode) throws InOutException {
    target.obtainComponent(fullName, sofanode);
  }

  public void distributeComponent (String fullName, String[] sofanodes) throws InOutException {
    target.distributeComponent(fullName, sofanodes);
  }
*/

  public void obtain (String[] offers, String[] components, String sofaNode) throws InOutException {
    target.obtain(offers, components, sofaNode);
  }

  public void distribute (String[] offers, String[] components, String[] sofaNodes) throws InOutException {
    target.distribute(offers, components, sofaNodes);
  }

  public void obtainOffers (String[] offers, String sofaNode) throws InOutException {
    target.obtainOffers(offers, sofaNode);
  }

  public void distributeOffers (String[] offers, String[] sofaNodes) throws InOutException {
    target.distributeOffers(offers, sofaNodes);
  }

  public void obtainComponents (String[] components, String sofaNode) throws InOutException {
    target.obtainComponents(components, sofaNode);
  }

  public void distributeComponents (String[] components, String[] sofaNodes) throws InOutException {
    target.distributeComponents(components, sofaNodes);
  }

  public Bundle list () throws InOutException {
    return target.list();
  }
}
