/**
 * InOut2ClientRMISkel.java is a part of the SOFA project.
 * This file was created by pepan on 16.4.2003.
 */
package SOFA.SOFAnode.InOut.Connector;

import SOFA.Connector.Linkable;
import SOFA.Connector.ConnectorTransportException;
import SOFA.SOFAnode.InOut.Bundle;
import SOFA.SOFAnode.InOut.InOutException;
import SOFA.SOFAnode.TR.Impl.BundleImpl;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.io.IOException;

/**
 * @author Petr Panuska
 */
public class InOut2ClientRMISkel extends UnicastRemoteObject implements CNInOut2ClientRemote, Linkable {
  CNInOut2Client target;

  public InOut2ClientRMISkel (String url) throws RemoteException, java.net.MalformedURLException, java.rmi.NotBoundException {
    super();
    String rmihost = System.getProperty("sofa.rmihost", "localhost");
    String rmiport = System.getProperty("sofa.rmiport", "1099");
    // because of remote registering of services
    // don't be confused with the name '.DeplDockRegistry.RgRMIDock', it has nothing to do with a Depl. Dock
    // for more info contact Petr Hnetynka
    SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock rg = (SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock) java.rmi.Naming.lookup("//" + rmihost + ":" + rmiport + "/RgRMIDock");
    rg.rebind(url, this);
  }

  public void link (Object target) {
    this.target = (CNInOut2Client) target;
  }

/*
  public void obtainComponent (String fullName, String sofanode) throws InOutException {
    target.obtainComponent(fullName, sofanode);
  }

  public void distributeComponent (String fullName, String[] sofanodes) throws InOutException {
    target.distributeComponent(fullName, sofanodes);
  }

*/
  public void obtain (String[] offers, String[] components, String sofaNode) throws RemoteException, InOutException {
    target.obtain(offers, components, sofaNode);
  }

  public void distribute (String[] offers, String[] components, String[] sofaNodes) throws RemoteException, InOutException {
    target.distribute(offers, components, sofaNodes);
  }

  public void obtainOffers (String[] offers, String sofaNode) throws RemoteException, InOutException {
    target.obtainOffers(offers, sofaNode);
  }

  public void distributeOffers (String[] offers, String[] sofaNodes) throws RemoteException, InOutException {
    target.distributeOffers(offers, sofaNodes);
  }

  public void obtainComponents (String[] components, String sofaNode) throws RemoteException, InOutException {
    target.obtainComponents(components, sofaNode);
  }

  public void distributeComponents (String[] components, String[] sofaNodes) throws RemoteException, InOutException {
    target.distributeComponents(components, sofaNodes);
  }

  public byte[] list () throws InOutException {
    BundleImpl bundle = (BundleImpl) target.list();
    byte[] ret = null;
    try {
      cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      bundle._write(os);
      os.close();
      ret = os.toByteArray();
    } catch (IOException e) {
      throw new ConnectorTransportException("Can't serialize in the 'InOut2ClientRMISkel.list'.", e);
    }
    return ret;
  }
}
