/**
 * InOut2ClientRMIStub.java is a part of the SOFA project.
 * This file was created by pepan on 16.4.2003.
 */
package SOFA.SOFAnode.InOut.Connector;

import SOFA.Connector.ConnectorTransportException;
import SOFA.SOFAnode.InOut.Bundle;
import SOFA.SOFAnode.InOut.InOutException;
import SOFA.SOFAnode.TR.Impl.BundleImpl;

import java.rmi.RemoteException;
import java.io.FileOutputStream;

/**
 * @author Petr Panuska
 */
public class InOut2ClientRMIStub implements CNInOut2Client {

  protected CNInOut2ClientRemote target;

  public InOut2ClientRMIStub (String url) throws RemoteException {
    try {
      target = (CNInOut2ClientRemote) java.rmi.Naming.lookup(url);
    } catch (java.net.MalformedURLException e) {
      throw new RemoteException("Can't create CNInOut2ClientRemote.\n" + url + "\n", e);
    } catch (java.rmi.NotBoundException e) {
      throw new RemoteException("Can't create CNInOut2ClientRemote.\n" + url + "\n", e);
    }
  }

//  public void obtainComponent (String fullName, String sofanode) throws InOutException {
//    try {
//      target.obtainComponent(fullName, sofanode);
//    } catch (RemoteException e) {
//      throw new ConnectorTransportException("Remote exception in the 'InOut2ClientRMIStub.obtainComponent'.", e);
//    }
//  }
//
//  public void distributeComponent (String fullName, String[] sofanodes) throws InOutException {
//    try {
//      target.distributeComponent(fullName, sofanodes);
//    } catch (RemoteException e) {
//      throw new ConnectorTransportException("Remote exception in the 'InOut2ClientRMIStub.distributeComponent'.", e);
//    }
//  }

  public void obtain (String[] offers, String[] components, String sofaNode) throws InOutException {
    try {
      target.obtain(offers, components, sofaNode);
    } catch (RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'InOut2ClientRMIStub.obtain'.", e);
    }
  }

  public void distribute (String[] offers, String[] components, String[] sofaNodes) throws InOutException {
    try {
      target.distribute(offers, components, sofaNodes);
    } catch (RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'InOut2ClientRMIStub.distribute'.", e);
    }
  }

  public void obtainOffers (String[] offers, String sofaNode) throws InOutException {
    try {
      target.obtainOffers(offers, sofaNode);
    } catch (RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'InOut2ClientRMIStub.obtainOffers'.", e);
    }
  }

  public void distributeOffers (String[] offers, String[] sofaNodes) throws InOutException {
    try {
      target.distributeOffers(offers, sofaNodes);
    } catch (RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'InOut2ClientRMIStub.distributeOffers'.", e);
    }
  }

  public void obtainComponents (String[] components, String sofaNode) throws InOutException {
    try {
      target.obtainComponents(components, sofaNode);
    } catch (RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'InOut2ClientRMIStub.obtainComponents'.", e);
    }
  }

  public void distributeComponents (String[] components, String[] sofaNodes) throws InOutException {
    try {
      target.distributeComponents(components, sofaNodes);
    } catch (RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'InOut2ClientRMIStub.distributeComponents'.", e);
    }
  }

  public Bundle list () throws InOutException {
    try {
      byte[] s = target.list();
      BundleImpl bundle = new BundleImpl();
      bundle._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(s));
      return bundle;
    } catch (java.rmi.RemoteException e) {
      throw new ConnectorTransportException("Remote exception in the 'InOut2ClientRMIStub.list'.", e);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("IOException exception in the 'InOut2ClientRMIStub.list'.", e);
    }
  }

}
