/**
 * InOut2InOutRMISkel.java is a part of the SOFA project.
 * This file was created by pepan on 18.4.2003.
 */
package SOFA.SOFAnode.InOut.Connector;

import SOFA.Connector.ConnectorTransportException;
import SOFA.Connector.Linkable;
import SOFA.SOFAnode.InOut.InOutException;
import SOFA.SOFAnode.TR.ComponentInfo;
import SOFA.SOFAnode.TR.Impl.BundleImpl;

import java.io.IOException;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

/**
 *
 * @author Petr Panuska
 */
public class InOut2InOutRMISkel extends UnicastRemoteObject implements CNInOut2InOutRemote, Linkable {
  CNInOut2InOut target;

  public InOut2InOutRMISkel (String url) throws RemoteException, java.net.MalformedURLException, java.rmi.NotBoundException {
    super();
    String rmihost = System.getProperty("sofa.rmihost", "localhost");
    String rmiport = System.getProperty("sofa.rmiport", "1099");
    // because of remote registering of services
    // don't be confused with the name '.DeplDockRegistry.RgRMIDock', it has nothing to do with a Depl. Dock
    // for more info contact Petr Hnetynka
    SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock rg = (SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock) java.rmi.Naming.lookup("//" + rmihost + ":" + rmiport + "/RgRMIDock");
    rg.rebind(url, this);
  }

  public void link (Object target) {
    this.target = (CNInOut2InOut) target;
  }

  public byte[] pullBundle (ComponentInfo[] descs, ComponentInfo[] comps, boolean inferiors) throws RemoteException, InOutException {
    BundleImpl bundle = (BundleImpl) target.pullBundle(descs, comps, inferiors);
    byte[] ret = null;
    try {
      cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      bundle._write(os);
      os.close();
      ret = os.toByteArray();
    } catch (IOException e) {
      throw new ConnectorTransportException("Can't serialize in the 'InOut2InOutRMISkel.pullBundle'.", e);
    }
    return ret;
  }

  public void pushBundle (byte[] bundleData) throws RemoteException, InOutException {
    BundleImpl bundle = new BundleImpl();
    try {
      bundle._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(bundleData));
    } catch (IOException e) {
      throw new ConnectorTransportException("Can't serialize in the 'InOut2InOutRMISkel.pushBundle'.", e);
    }
    target.pushBundle(bundle);
  }
}
