/* $Id: CompAModule.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompAModule extends CompContainedContainerIm {

  public CompAModule(ID id, CompContainer in, CompRepository inRep) {
    super(ObjectsKind.o_AModule, id, in, inRep);
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    CompContained[] cont = contents();
    for (int i=0;i<cont.length;i++) {
      cont[i].checkConsist(props, rep);
    }
  }

  public void addToNormal(Container obj, CDLRepository normRep, java.util.ArrayList delayed) throws CDLExceptToNormal, CDLExceptRemote, CDLExceptLock {
    cont.toFirst();
    try {
      for (int i=0;i<cont.size(); i++) {
        CompContained akt = (CompContained) cont.aktual();
        switch (akt.objectKind()) {
        // *****************
        case ObjectsKind.o_AModule:
          Contained[] cmod = obj.lookup_name(akt.getIdent().name);
          if ((cmod == null) || (cmod.length == 0)) { //create new module
            AModuleDef mod = null;
            try {
              mod = ((AModuleDef) obj).create_amodule(akt.getIdent().id);
            } catch (TIRExceptCreate ecr) {
              throw new CDLExceptToNormal("Can't create amodule "+((CompContained)akt).fullName());
            }
            if (mod==null)
              throw new CDLExceptToNormal("Can't create amodule "+((CompContained)akt).fullName());
            ((CompContainer) akt).addToNormal(mod, normRep, delayed);
          } else { // use old module
            if (cmod.length!=1)
              throw new CDLExceptToNormal("Unexpected error");
            ((CompContainer) akt).addToNormal((Container) cmod[0], normRep, delayed);
          }
          break;
        // *****************
        case ObjectsKind.o_Architecture:
          try {
            ArchitectureDef arch = ((AModuleDef) obj).create_architecture(akt.getIdent().id, (FrameDef) ((CompArchitecture) akt).frame.toNormal(normRep), ((CompArchitecture) akt).isSystem);
            if (arch == null) 
              throw new CDLExceptToNormal("Can't create architecture "+((CompContained)akt).fullName());
            ((CompArchitecture) akt).addToNormal(arch, normRep, delayed);
          } catch (TIRExceptCreate ecr) {
            throw new CDLExceptToNormal("Can't create architecture "+((CompContained)akt).fullName());
          }
          break;
        default:
          throw new CDLExceptToNormal("Unexcepted kind of object");
        }
        cont.toNext();
      }
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptLock e) {
      throw new CDLExceptLock("Repository is locked.");
    }
  }
}
