/* $Id: CompEnum.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompEnum extends CompContainedIm implements CompType {
  EnumList members;   // list of strings
  public CompEnum(ID id, CompContainer in, CompRepository inRep, EnumList m) {
    super(ObjectsKind.o_Enum, id, in, inRep);
    members = m;
  }

  public void checkConsist(EnumList props, CompRepository rep) {}

  /** from CompType */
  public CDLType toNormal(CDLRepository newRep) throws CDLExceptToNormal {
    // never call this
    throw new CDLExceptToNormal("It should never throw");
  }

  public void addToNormal(EnumDef enum) throws CDLExceptToNormal, CDLExceptRemote, CDLExceptLock {
    if (id.isin == IDKind.versiontag) {
      try {
        enum.tag(id.tag);
      } catch (RemoteException e) {
        throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
      } catch (TIRExceptLock e) {
        throw new CDLExceptLock("Repository is locked.");
      } catch (TIRExceptCreate ecr) {
        throw new CDLExceptToNormal("Can't set tag for "+ fullName());
      }
    }
    members.toFirst();
    for(int i=0;i<members.size();i++) {
      try {
        if (enum.create_member((String) members.aktual())==null)
          throw new CDLExceptToNormal("Can't create member "+(String) members.aktual()+" in enum "+fullName());
      } catch (RemoteException e) {
        throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
      } catch (TIRExceptLock e) {
        throw new CDLExceptLock("Repository is locked.");
      } catch (TIRExceptCreate ecr) {
        throw new CDLExceptToNormal("Can't create member "+(String) members.aktual()+" in enum "+fullName());
      }
      members.toNext();
    }
  }
}
