/* $Id: CompVG.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompVG extends CompExprOper {
  List elements;
  
  public CompVG(List els) {
    super(CompExprKind.e_valuegen);
    if (els==null)
      elements = new List();
    else
      elements = els;
  }

  public int type() {
    return CompExprKind.e_valuegen;
  }
  
  public boolean isProp() {
    elements.toFirst();
    for (int i=0;i<elements.size(); i++) {
      CompVGElem el = (CompVGElem) elements.aktual();
      if (el.expr1.isProp())
        return true;
      if (el.expr2 != null)
        if (el.expr2.isProp())
          return true;
      elements.toNext();
    }
    return false;
  }

  public EnumList nameProp(CompRepository rep) throws CDLExceptRemote, CDLExceptLock {
    EnumList ret = new EnumList();
    elements.toFirst();
    for (int i=0;i<elements.size(); i++) {
      CompVGElem el = (CompVGElem) elements.aktual();
      int j;
      EnumList l = el.expr1.nameProp(rep);
      l.toFirst();
      for (j=0;j<l.size();j++) {
        ret.addName((String) l.aktual());
        l.toNext();
      }
      if (el.expr2 != null)
        l = el.expr2.nameProp(rep);
        l.toFirst();
        for (j=0;j<l.size();j++) {
          ret.addName((String) l.aktual());
          l.toNext();
        }
      elements.toNext();
    }
    return ret;
  }

  public ExprOperDef toNormal(CDLRepository rep) throws CDLExceptToNormal, CDLExceptRemote, CDLExceptLock {
    try {
      ValueGen ret = ((Repository) rep.get_containing_repository()).create_valuegen();
      elements.toFirst();
      for(int i=0;i<elements.size();i++) {
        ExprOperDef ex1 = ((CompVGElem) elements.aktual()).expr1.toNormal(rep);
        ExprOperDef ex2 = null;
        if (((CompVGElem) elements.aktual()).expr2 != null)
          ex2 = ((CompVGElem) elements.aktual()).expr2.toNormal(rep);
        if ((ret.create_element(ex1, ex2))==null)
          throw new CDLExceptToNormal("Can't create value generator");
        elements.toNext();
      }
      return ret;
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptCreate ecr) {
      throw new CDLExceptToNormal("Can't create expression");
    }
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    elements.toFirst();
    for(int i=0;i<elements.size();i++) {
      ((CompVGElem) elements.aktual()).checkConsist(props, rep);
      elements.toNext();
    }
  }

  public String toString() {
    StringBuffer sb = new StringBuffer("<");
    elements.toFirst();
    for (int i=0;i<elements.size();i++) {
      if (i!=0)
        sb.append(",");
      sb.append(((CompVGElem) elements.aktual()).toString());
      elements.toNext();     
    }
    sb.append(">");
    return sb.toString();
  }
}
