/* $Id: Debug.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CodeGen;

import SOFA.SOFAnode.Made.TIR.*;
 
/** Debugging messages.
  * Switch it on by java property   codegen.debug=yes
  */
public class Debug {
  /** Print message */
  public static void println(String msg) {
    if ((System.getProperty("codegen.debug", "no").compareTo("yes"))==0)
      System.out.println("*** "+msg+" ***");
  }
  /** Test if debuging is set */
  public static boolean isDebug() {
    if ((System.getProperty("codegen.debug", "no").compareTo("yes"))==0)
      return true;
    return false;
  }
  /** Print object */
  public static void println(Object obj) {
    if ((System.getProperty("codegen.debug", "no").compareTo("yes"))==0)
      System.out.println("*** "+obj.toString()+" ***");
  }
  /** Print array of objects */
  public static void println(Object[] obj) {
    if ((System.getProperty("codegen.debug", "no").compareTo("yes"))==0) {
      System.out.println("***");
      for (int i=0;i<obj.length;i++) {
        System.out.println(obj[i].toString());
      }
      System.out.println("***");     
    }
  }

  /** Print array of TIR Contained objects */
  public static void println(Contained[] obj) {
    if ((System.getProperty("codegen.debug", "no").compareTo("yes"))==0) {
      System.out.println("***");
      for (int i=0;i<obj.length;i++) {
        try {
          Identification id = obj[i].get_identification();
          System.out.println(id.absolute_name().name()+"?"+id.version());
        } catch (java.rmi.RemoteException e) {
          System.out.println("  Remote exception --> "+e.getMessage());
        }
      }
      System.out.println("***");     
    }
  }

  /** Print list of TIR Contained objects */
  public static void println(ObjectList obj) {
    if ((System.getProperty("codegen.debug", "no").compareTo("yes"))==0) {
      System.out.println("***");
      for (int i=0;i<obj.size();i++) {
        try {
          Identification id = obj.getObject(i).get_identification();
          System.out.println(id.absolute_name().name()+"?"+id.version());
        } catch (java.rmi.RemoteException e) {
          System.out.println("  Remote exception --> "+e.getMessage());
        }
      }
      System.out.println("***");     
    }
  }

  /** Print list of Generated objects */
  public static void println(GenObjectList obj) {
    if ((System.getProperty("codegen.debug", "no").compareTo("yes"))==0) {
      System.out.println("***");
      for (int i=0;i<obj.size();i++) {
        System.out.println(obj.getObject(i).toString());
      }
      System.out.println("***");     
    }
  }
}
