/* $Id: WstringDefImpl.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.io.*;

public class WstringDefImpl extends UnicastRemoteObject implements WstringDef, TIRImplObject {
  ExprOperDef bd;
  DefinitionKindImpl defKindImpl;
  StateKindImpl stKindImpl;

  public WstringDefImpl(ExprOperDef bound) throws RemoteException {
    bd = bound;
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_Wstring);
    stKindImpl = new StateKindImpl(StateKind.sk_work);
  }

  public WstringDefImpl() throws RemoteException {
    bd = null;
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_Wstring);
    stKindImpl = new StateKindImpl(StateKind.sk_normal);
  }

  public ExprOperDef bound() throws RemoteException {
    return bd;
  }

  /* from interface TIRObject */
  public DefinitionKind get_def_kind() throws RemoteException {
    return (DefinitionKind) defKindImpl;
  }

  /* from interface TIRObject */
  public StateKind get_state() throws RemoteException {
    return (StateKind) stKindImpl;
  }

  public void load(Storage st) throws RemoteException, TIRExceptStorage {
    ;
  }

  public void save(Storage st) throws RemoteException, TIRExceptStorage {
    ;
  }

  public void postLoad(RepositoryImpl r) throws RemoteException, TIRExceptStorage {
    ((TIRImplObject) bd).postLoad(r);
  }

  public boolean isNew() {
    return (stKindImpl.value()==StateKind.sk_work);
  }

  public void canCommit() throws RemoteException, TIRExceptCommit {;}

  public void doCommit(Container in, Repository rep) throws RemoteException {
    if (stKindImpl.value()==StateKind.sk_normal)
      return;
    if (isNew()) {
      stKindImpl.toNormal();
      ((TIRImplObject)bd).doCommit(in,rep);
    }
  }

  public void doAbort(long workId) throws RemoteException {}
}
