/* $Id: CallConGen.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Made.Tools;
import java.io.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import SOFA.SOFAnode.Run.SpecFile;

/** Call connector generator with correct arguments.
  *
  * @author Petr Hnetynka
  */
public class CallConGen {
  
  
  /** Argument is depldescr form of component.
    * Java properties:
    * <ul>
    * <li>file.root - from which directory (inserted) files will be searched
    * <li>sofa.tr.dir - directory with TR
    * <li>..and all properties for connector generator
    * </ul>
    */
  public static void main(String[] argv) {
    if (argv.length < 1) {
      System.out.println("too few arguments");
      System.exit(1);
    }

    String trDir = System.getProperty("sofa.tr.dir", null);
    if (trDir == null) {
      System.out.println("Specify TR directrory (java property \"sofa.tr.dir\")");
      System.exit(1);
    }

    SpecFile specFile = null;
    try {
      specFile = SpecFile.getSpecFileFromFile(argv[0]);
    } catch (java.io.IOException e) {
      System.out.println("IOException: "+e.getMessage());
      System.exit(1);
    } catch (javax.xml.parsers.ParserConfigurationException e) {
      System.out.println("ParserConfigurationException: "+e.getMessage() );
      System.exit(1);
    } catch (org.xml.sax.SAXException e) {
      System.out.println("SAXException: "+e.getMessage() );
      System.exit(1);
    }

    String arch = specFile.getFullArchName();
    arch = arch.substring(0, arch.indexOf('?'));
    String version = specFile.getImplVersion();
    String sdir = trDir+File.separator+"impl"+File.separator+InstallToTR.fullNameToFileName(arch)+File.separator+version+File.separator;
//    System.out.println(sdir);
    String inArgv[] = new String [2];
    inArgv[0] = sdir + "run.dc";
    inArgv[1] = sdir + "run.dd";

    try {
      SOFA.Connector.ECG.test.main(inArgv);
    } catch (Exception e) {
      e.printStackTrace();
      System.exit(1);
    }
    
  }
}
