/* $Id: RunTIRAndCCNS.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Run;

import SOFA.SOFAnode.Made.TIR.Impl.RepositoryImpl;
import SOFA.SOFAnode.Run.CCNS.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.RMISecurityManager;
import java.rmi.Naming;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class RunTIRAndCCNS {

  /** Runs both TIR and CCNS. The used java properties is: sofa.rmiport, sofa.rmihost,
    * sofa.nodename, sofa.connector.ccns
    * 
    * @param argv 
    */
  public static void main(String[] argv) {
    if (System.getSecurityManager() == null) {
      System.setSecurityManager(new RMISecurityManager());
    }
    
    try {
      if (argv.length==0) {
        System.err.println("Set directory with repository to the first argument.");
        System.exit(1);
      }
      String rmiport = System.getProperty("sofa.rmiport","1099");
      String rmihost = System.getProperty("sofa.rmihost","localhost");
      String sofaNodeName = System.getProperty("sofa.nodename","");
      
      if (sofaNodeName.compareTo("")==0) {
        try {
          sofaNodeName = InetAddress.getLocalHost().getHostName();
        } catch (UnknownHostException e) { 
          System.err.println("Can't get host name. Set name to property \"sofa.nodename\"");
          System.exit(1);
        }
      }

      System.setProperty("sofa.nodename",sofaNodeName);
      
      RepositoryImpl repository = new RepositoryImpl(argv[0],sofaNodeName);
      System.out.print("Registering TIR....");
      Naming.rebind("//"+rmihost+":"+rmiport+"/Repository", repository);
      System.out.println("OK");

      System.out.print("Starting CCNS....");
      ConnectorCacheNSImpl ccns = new ConnectorCacheNSImpl();
      System.out.println("OK");
      System.out.print("Registering CCNS....");
      Naming.rebind("//"+rmihost+":"+rmiport+"/CCNS", ccns);
      System.out.println("OK");

    } catch (Exception e) {
      System.out.println("Exception " + e.getMessage());
      e.printStackTrace();
    }

  }
}
