/* $Id: TestMain.java,v 1.1 2003/03/17 10:56:19 hnetynka Exp $ */
package SOFA.Tools.Resolver;

import org.objectweb.asm.*;
import java.io.*;

/** Testing main class.
  * 
  * @author Petr Hnetynka
  */
public class TestMain {
  /** main method
    * 
    * @param argv 1st argument - translation table, next arguments - class files
    * @throws Exception 
    */
  public static final void main(String[] argv) throws Exception {
    java.util.Hashtable trTable = readTable(argv[0]);
    Resolver resolver = new Resolver(trTable);
    for(int i=1; i<argv.length; i++) {
      String newName = (String) trTable.get(argv[i].substring(0, argv[i].length()-6));
      if (newName == null) {
        newName = argv[i].substring(0, argv[i].length()-6);
        System.out.println("WARNING: file "+argv[i]+" will be rewritten.");
      }
      System.out.print("Processing file "+argv[i]+"...");
      FileInputStream is = new FileInputStream(argv[i]);
      byte[] b = resolver.process(is);
      is.close();
      FileOutputStream os = new FileOutputStream(newName+".class");
      os.write(b);
      os.close();
      System.out.println("OK");
    }
  }

  private static java.util.Hashtable readTable(String fname) throws Exception {
    java.util.Hashtable trTable = new java.util.Hashtable();
    BufferedReader ir = new BufferedReader(new FileReader(fname));
    String ln;
    while ((ln = ir.readLine()) != null) {
      int sp = ln.indexOf(' ');
      if (sp != -1) 
        trTable.put(ln.substring(0,sp), ln.substring(sp+1));
    }
    ir.close();
    return trTable;
  }
}
